# Update program parameter

## PUT /public/v1/program/programs/{programId}/parameters/{id}

>

```json
{"openapi":"3.0.1","info":{"title":"Marketplace API","version":"prod-4.0.155-g3cf2ba3f"},"servers":[{"url":"https://api.platform.softwareone.com"}],"paths":{"/public/v1/program/programs/{programId}/parameters/{id}":{"put":{"tags":["ProgramParameters"],"parameters":[{"name":"programId","in":"path","required":true,"schema":{"type":"string"}},{"name":"id","in":"path","required":true,"schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/UpdateProgramParameter"}},"text/json":{"schema":{"$ref":"#/components/schemas/UpdateProgramParameter"}},"application/*+json":{"schema":{"$ref":"#/components/schemas/UpdateProgramParameter"}}}},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProgramParameterDefinition"}}}},"400":{"description":"Bad Request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}},"404":{"description":"Not Found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"UpdateProgramParameter":{"type":"object","properties":{"name":{"type":"string"},"description":{"type":"string"},"externalId":{"type":"string","nullable":true},"displayOrder":{"type":"integer","format":"int32"},"constraints":{"type":"object","properties":{"Required":{"type":"boolean"},"Hidden":{"type":"boolean"},"ReadOnly":{"type":"boolean"}},"additionalProperties":false},"options":{"type":"object","oneOf":[{"$ref":"#/components/schemas/AddressOptions"},{"$ref":"#/components/schemas/CheckboxOptions"},{"$ref":"#/components/schemas/ChoiceOptions"},{"$ref":"#/components/schemas/DataObjectOptions"},{"$ref":"#/components/schemas/ContactOptions"},{"$ref":"#/components/schemas/DateOptions"},{"$ref":"#/components/schemas/DropDownOptions"},{"$ref":"#/components/schemas/EmailOptions"},{"$ref":"#/components/schemas/HeadingOptions"},{"$ref":"#/components/schemas/MultiLineTextOptions"},{"$ref":"#/components/schemas/SingleLineTextOptions"},{"$ref":"#/components/schemas/SubdomainOptions"}]},"group":{"type":"object","allOf":[{"$ref":"#/components/schemas/RequestObjectLink"}]}},"additionalProperties":false},"AddressOptions":{"type":"object","properties":{"hintText":{"type":"string"},"defaultValue":{"type":"string","allOf":[{"$ref":"#/components/schemas/DefaultParameterAddress"}]}},"additionalProperties":false},"DefaultParameterAddress":{"enum":["None","Buyer","Seller","Licensee"],"type":"string"},"CheckboxOptions":{"type":"object","properties":{"hintText":{"type":"string"},"optionsList":{"type":"array","items":{"$ref":"#/components/schemas/SelectionOption"}},"defaultValue":{"type":"array","items":{"type":"string"},"nullable":true}},"additionalProperties":false},"SelectionOption":{"type":"object","properties":{"label":{"type":"string"},"value":{"type":"string"},"description":{"type":"string","nullable":true}},"additionalProperties":false},"ChoiceOptions":{"type":"object","properties":{"hintText":{"type":"string"},"optionsList":{"type":"array","items":{"$ref":"#/components/schemas/SelectionOption"}},"defaultValue":{"type":"string","nullable":true}},"additionalProperties":false},"DataObjectOptions":{"type":"object","properties":{"hintText":{"type":"string"},"defaultValue":{"type":"string","nullable":true},"objectType":{"type":"string","allOf":[{"$ref":"#/components/schemas/DataObjectType"}]}},"additionalProperties":false},"DataObjectType":{"enum":["Json","Xml"],"type":"string"},"ContactOptions":{"type":"object","properties":{"hintText":{"type":"string"},"defaultValue":{"type":"string","allOf":[{"$ref":"#/components/schemas/DefaultParameterContact"}]},"phoneMandatory":{"type":"boolean"}},"additionalProperties":false},"DefaultParameterContact":{"enum":["None","Buyer","Licensee","CurrentlySignedInUser"],"type":"string"},"DateOptions":{"type":"object","properties":{"hintText":{"type":"string"},"dateRange":{"type":"boolean"},"minAvailableDate":{"type":"string","format":"date","nullable":true},"maxAvailableDate":{"type":"string","format":"date","nullable":true},"defaultValue":{"oneOf":[{"$ref":"#/components/schemas/RangeDateParameter"},{"type":"string"}],"nullable":true}},"additionalProperties":false},"RangeDateParameter":{"allOf":[{"$ref":"#/components/schemas/DateParameter"},{"type":"object","properties":{"start":{"type":"string","format":"date"},"end":{"type":"string","format":"date"}},"additionalProperties":false}]},"DateParameter":{"type":"object","additionalProperties":false},"DropDownOptions":{"type":"object","properties":{"hintText":{"type":"string"},"placeholderText":{"type":"string","nullable":true},"optionsList":{"type":"array","items":{"$ref":"#/components/schemas/BasicSelectionOption"}},"description":{"type":"string","nullable":true},"defaultValue":{"type":"string","nullable":true}},"additionalProperties":false},"BasicSelectionOption":{"type":"object","properties":{"label":{"type":"string"},"value":{"type":"string"}},"additionalProperties":false},"EmailOptions":{"type":"object","properties":{"placeholderText":{"type":"string"},"hintText":{"type":"string"},"defaultValue":{"type":"string","allOf":[{"$ref":"#/components/schemas/DefaultParameterEmail"}]}},"additionalProperties":false},"DefaultParameterEmail":{"enum":["None","CurrentlySignedInUser"],"type":"string"},"HeadingOptions":{"type":"object","additionalProperties":false},"MultiLineTextOptions":{"type":"object","properties":{"placeholderText":{"type":"string"},"hintText":{"type":"string"},"minChar":{"type":"integer","format":"int32","nullable":true},"maxChar":{"type":"integer","format":"int32","nullable":true},"defaultValue":{"type":"string","nullable":true}},"additionalProperties":false},"SingleLineTextOptions":{"type":"object","properties":{"placeholderText":{"type":"string"},"hintText":{"type":"string"},"pattern":{"type":"string","nullable":true},"minChar":{"type":"integer","format":"int32","nullable":true},"maxChar":{"type":"integer","format":"int32","nullable":true},"defaultValue":{"type":"string","nullable":true}},"additionalProperties":false},"SubdomainOptions":{"type":"object","properties":{"placeholderText":{"type":"string"},"hintText":{"type":"string"},"domainSuffix":{"type":"string"}},"additionalProperties":false},"RequestObjectLink":{"type":"object","properties":{"id":{"type":"string"}},"additionalProperties":false},"ProgramParameterDefinition":{"type":"object","properties":{"id":{"type":"string"},"audit":{"type":"object","allOf":[{"$ref":"#/components/schemas/Audit"}]},"$meta":{"type":"object","allOf":[{"$ref":"#/components/schemas/Metadata"}]},"name":{"type":"string"},"description":{"type":"string"},"group":{"type":"object","allOf":[{"$ref":"#/components/schemas/ProgramParameterGroupRef"}]},"scope":{"enum":["Enrollment"],"type":"string"},"phase":{"enum":["Order","Fulfillment"],"type":"string"},"externalId":{"type":"string","nullable":true},"displayOrder":{"type":"integer","format":"int32"},"constraints":{"type":"object","allOf":[{"$ref":"#/components/schemas/Constraints"}]},"program":{"type":"object","allOf":[{"$ref":"#/components/schemas/ProgramRef"}]},"options":{"nullable":true,"readOnly":true},"type":{"enum":["SingleLineText","MultiLineText","Address","Contact","Checkbox","Choice","Subdomain","Heading","DropDown","Email","DataObject","Date"],"type":"string"},"status":{"type":"string"}},"additionalProperties":false},"Audit":{"type":"object","properties":{"created":{"type":"object","allOf":[{"$ref":"#/components/schemas/Event"}]},"updated":{"type":"object","allOf":[{"$ref":"#/components/schemas/Event"}]}},"additionalProperties":false},"Event":{"type":"object","properties":{"at":{"type":"string","format":"date-time","nullable":true},"by":{"type":"object","allOf":[{"$ref":"#/components/schemas/Identity"}]}},"additionalProperties":false},"Identity":{"type":"object","properties":{"id":{"type":"string"},"audit":{"type":"object","allOf":[{"$ref":"#/components/schemas/Audit"}]},"$meta":{"type":"object","allOf":[{"$ref":"#/components/schemas/Metadata"}]},"name":{"type":"string"},"icon":{"type":"string","nullable":true}},"additionalProperties":false},"Metadata":{"type":"object","properties":{"omitted":{"type":"array","items":{"type":"string"}}},"additionalProperties":false},"ProgramParameterGroupRef":{"type":"object","properties":{"id":{"type":"string"},"name":{"type":"string"}},"additionalProperties":false},"Constraints":{"type":"object","properties":{"hidden":{"type":"boolean","nullable":true},"readonly":{"type":"boolean","nullable":true},"required":{"type":"boolean","nullable":true}},"additionalProperties":false},"ProgramRef":{"type":"object","properties":{"id":{"type":"string"},"name":{"type":"string"},"status":{"type":"string","allOf":[{"$ref":"#/components/schemas/ProgramStatus"}]},"applicableTo":{"type":"string","allOf":[{"$ref":"#/components/schemas/ProgramApplicableTo"}]},"products":{"type":"array","items":{"$ref":"#/components/schemas/Product"},"nullable":true}},"additionalProperties":false},"ProgramStatus":{"enum":["None","Draft","Published","Unpublished","Deleted"],"type":"string"},"ProgramApplicableTo":{"enum":["Buyer","Licensee"],"type":"string"},"Product":{"type":"object","properties":{"id":{"type":"string"},"audit":{"type":"object","allOf":[{"$ref":"#/components/schemas/ProductAudit"}]},"$meta":{"type":"object","allOf":[{"$ref":"#/components/schemas/Metadata"}]},"name":{"type":"string"},"shortDescription":{"type":"string","nullable":true},"longDescription":{"type":"string","nullable":true},"externalIds":{"type":"object","allOf":[{"$ref":"#/components/schemas/ProductExternalIdBag"}]},"website":{"type":"string"},"icon":{"type":"string"},"status":{"type":"string"},"vendor":{"type":"object","allOf":[{"$ref":"#/components/schemas/AccountRef"}]},"settings":{"type":"object","allOf":[{"$ref":"#/components/schemas/ProductSettings"}]},"statistics":{"type":"object","allOf":[{"$ref":"#/components/schemas/ProductStatistics"}]}},"additionalProperties":false},"ProductAudit":{"type":"object","properties":{"created":{"type":"object","allOf":[{"$ref":"#/components/schemas/Event"}]},"updated":{"type":"object","allOf":[{"$ref":"#/components/schemas/Event"}]},"published":{"type":"object","allOf":[{"$ref":"#/components/schemas/Event"}]},"pending":{"type":"object","allOf":[{"$ref":"#/components/schemas/Event"}]},"unpublished":{"type":"object","allOf":[{"$ref":"#/components/schemas/Event"}]}},"additionalProperties":false},"ProductExternalIdBag":{"type":"object","properties":{"operations":{"type":"string","nullable":true},"defaultErpItem":{"type":"string","nullable":true}},"additionalProperties":false},"AccountRef":{"required":["name","status","type"],"type":"object","properties":{"id":{"type":"string"},"icon":{"type":"string","nullable":true},"type":{"type":"string","allOf":[{"$ref":"#/components/schemas/AccountType"}]},"status":{"type":"string","allOf":[{"$ref":"#/components/schemas/AccountStatus"}]},"name":{"maxLength":500,"minLength":1,"type":"string"}},"additionalProperties":false},"AccountType":{"enum":["Client","Vendor","Operations"],"type":"string"},"AccountStatus":{"enum":["Active","Enabled","Disabled"],"type":"string"},"ProductSettings":{"type":"object","properties":{"productOrdering":{"type":"boolean"},"productRequests":{"type":"object","allOf":[{"$ref":"#/components/schemas/ProductRequestsSetting"}]},"itemSelection":{"type":"boolean"},"orderQueueChanges":{"type":"boolean"},"preValidation":{"type":"object","allOf":[{"$ref":"#/components/schemas/PreValidationSettings"}]},"splitBilling":{"type":"object","allOf":[{"$ref":"#/components/schemas/ProductSplitBillingRequestsSetting"}]},"subscriptionCessation":{"type":"object","allOf":[{"$ref":"#/components/schemas/SubscriptionCessationSetting"}]}},"additionalProperties":false},"ProductRequestsSetting":{"type":"object","properties":{"enabled":{"type":"boolean"},"name":{"type":"string","nullable":true},"label":{"type":"string","nullable":true}},"additionalProperties":false},"PreValidationSettings":{"type":"object","properties":{"purchaseOrderDraft":{"type":"boolean"},"purchaseOrderQuerying":{"type":"boolean"},"changeOrderDraft":{"type":"boolean"},"configurationOrderDraft":{"type":"boolean"},"terminationOrder":{"type":"boolean"},"productRequest":{"type":"boolean"}},"additionalProperties":false},"ProductSplitBillingRequestsSetting":{"type":"object","properties":{"enabled":{"type":"boolean"},"type":{"type":"string","nullable":true}},"additionalProperties":false},"SubscriptionCessationSetting":{"type":"object","properties":{"enabled":{"type":"boolean"},"mode":{"enum":["Termination","Auto-renewal","Termination or auto-renewal"],"type":"string","nullable":true}},"additionalProperties":false},"ProductStatistics":{"type":"object","properties":{"itemCount":{"type":"integer","format":"int32"},"ordersPlacedCount":{"type":"integer","format":"int32"},"agreementCount":{"type":"integer","format":"int32"},"subscriptionCount":{"type":"integer","format":"int32"},"requestCount":{"type":"integer","format":"int32"}},"additionalProperties":false},"ProblemDetails":{"type":"object","properties":{"type":{"type":"string","nullable":true},"title":{"type":"string","nullable":true},"status":{"type":"integer","format":"int32","nullable":true},"detail":{"type":"string","nullable":true},"instance":{"type":"string","nullable":true}},"additionalProperties":{}}}}}
```
